
/**
 * Creation and testing of a generic linked list, ListNode2.
 *
 * @author T. Andrew Yang
 */
public class ListNode2 {
    //private int data;

    private String data;
    private ListNode2 next;
    private static ListNode2 first; // a class variable that points to the first node in the list
    private static ListNode2 last; // points to the last node in the list
    private static int numberOfNodes = 0;

    public ListNode2() {
        this.data = null;
        this.next = null;
        return;
    }

    // Remove all occurrences of nodes with data equal to key.
    // Return 0 if no such nodes are found;
    // otherwise return the number of nodes found
    public static ListNode2 findAndRemove(ListNode2 list, String key) {

        int foundNodes = 0;
        ListNode2 tempNode = list;
        ListNode2 previous = list;

        for (int i = 0; tempNode != null; tempNode = tempNode.next, i++) {
            //System.out.println ("in findAndRemove(): Node " + i + ": " + tempNode.data);
            //System.out.println("previous node: " + previous.data);
            if (tempNode.data.equals(key)) { // found
                foundNodes++; // one such node is found
                if (tempNode == previous) { // first node
                    list = tempNode.next; // discard the original first
                } else if (tempNode == last) { //last node
                    last = previous; //discard the original last
                    last.next = null;
                } else { // somewhere in the middle
                    previous.next = tempNode.next; //bypass the current node
                }
                numberOfNodes--;
            } else { // not found in this node
                previous = tempNode; //previous advances only when no node was found and deleted
            }
        } //for
        System.out.println("Found " + foundNodes + " nodes with " + key);
        return list;
    }

    public static ListNode2 initializeList() {

        for (int i = 1; i < 5; i++, numberOfNodes++) {
            if (i == 1) { //the first node
                first = new ListNode2();
                last = first;
            } else {
                last.next = new ListNode2();
                last = last.next;
            }
            //last.data = new Integer(i).toString();
            switch (i % 3) {
                case 0:
                    last.data = "Adam";
                    break;
                case 1:
                    last.data = "Eve";
                    break;
                case 2:
                    last.data = "John";
                    break;
                default:
                    last.data = "Peter";
            }
            last.next = null;
            //System.out.printf("first: %s\n", first.data);
            //System.out.printf("last: %s\n", last.data);
        }
        return first;
    }

    // Add value as a new ListNode2 and insert it into the right spot
    // so the data are at ascending order
    public ListNode2 addSorted(String name) {
        return first;
    } // addSorted()

    public void displayAllNodes() {
        ListNode2 tempNode = this;
        for (int i = 1; tempNode != null; tempNode = tempNode.next, i++) {
            System.out.println("Node " + i + ": " + tempNode.data);
        }
        //System.out.println("Leaving displayAllNodes\n");
    }

    public static void main(String args[]) {
        ListNode2 list;
        //first = list;
        //last = list;
        //create a linked list
        list = initializeList();

        System.out.println("A new linked list was initialized: "
                + numberOfNodes + " nodes.");

        list.displayAllNodes();
        list.next.next.data = "1"; //set redundant nodes
        list.displayAllNodes();

        list = findAndRemove(list, "0");
        System.out.println("After deleing 0");
        list.displayAllNodes();
        list = findAndRemove(list, "1");
        System.out.println("After deleing 1");
        list.displayAllNodes();
        list = findAndRemove(list, "Eve");
        System.out.println("After deleing Eve");
        list.displayAllNodes();
    } //main
} // class: ListNode2

